//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  PaleVioletRed
#property indicator_color2  DeepSkyBlue
#property indicator_color3  DeepSkyBlue
#property indicator_width3  2
#property indicator_style2  STYLE_DOT
#property indicator_minimum 0

//
//
//
//
//

extern int DeviationsPeriod = 14;
extern int StochKPeriod     = 5;
extern int StochDPeriod     = 3;
extern int StochSmoothing   = 3;
extern int Price            = PRICE_CLOSE;

//
//
//
//
//

double bufferUpa[];
double bufferUpb[];
double stoch[];
double devs[];
double diffd[];
double diffm[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,bufferUpa);
   SetIndexBuffer(1,bufferUpb);
   SetIndexBuffer(2,stoch);
   SetIndexBuffer(3,devs);
   SetIndexBuffer(4,diffd);
   SetIndexBuffer(5,diffm);
         IndicatorShortName("Stoch ex ("+")");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//


int start()
{
   double alpha = 2.0 / (1.0+StochSmoothing);
   int limit,i,counted_bars=IndicatorCounted();
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      devs[i]  = iStdDev(NULL,0,DeviationsPeriod,0,MODE_SMA,Price,i);
      
         double min = devs[ArrayMinimum(devs,StochKPeriod,i)];
         double max = devs[ArrayMaximum(devs,StochKPeriod,i)];
      
      diffd[i] = devs[i] - min;
      diffm[i] = max     - min;
      
         double sumd = 0;
         double summ = 0.0000001;
         for (int k=0; k<StochDPeriod; k++)
         {
            sumd += diffd[i+k];
            summ += diffm[i+k];
         }
         double rawStoch = 100.0*sumd/summ;

      stoch[i]     = stoch[i+1] + alpha*(rawStoch-stoch[i+1]);
      bufferUpa[i] = 100;
      bufferUpb[i] =  95;
   }
   
   //
   //
   //
   //
   //
 
   return(0);
}

